<?php
/*
CMSimple Gallery plugin version 0.9 mod 0.1d
Modified for use with Lightbox2 or clones by HI 2008-03-25

Thanks goes to :
- Eric Lotgerink for the Dutch translation
- Martin Sereday for the Slovak translation
- Brge Nilssen for the Norwegian translation
- Florian Kirsten for the German translation
and of course all users giving feedback, making the gallery even better
- 0.9    : Bugfix whan saving/adding various info 
           - header("Location: http://".sv('HTTP_HOST').((dirname(sv('PHP_SELF')) == "/") ? "/" : dirname(sv('PHP_SELF'))."/").'
             changed to header('Location: '.$sn.'?'.$su.'
- 0.8    : Bugfix for admin when using foldernames with spaces
- 0.7    : Bugfix for php not reporting is_ececutable as expected
- 0.6    : Loads of changes in the admin part
- 0.5    : the design changed a bit a couple of <BR>
- 0.4    : Multilanguage commentfile made configurable, default value is set to 'false'
           - When enabled the comment files will get the extension -<language>.txt
           - Some minor bugs corrected in the language files
           - Comments and extra info with /" are now shown as "
           - Underscore (_) is removed when showing titles
- 0.3    : Some additional text fields can be activated fields are added in the
           language file under variable extra_info_fields seprated by comma.
           To activate the feature set show_extrainfo to true
           - CCS-browser-compatibility optimized, thumb class added
           - Improved error handling 
           - Error messages instead of white screen, I hope ;o)
           - XHTML compatible output
           - Multi language support for comments when running in cmsimple.dk
             multiple language setup.
           - Some bugs corrected
- 0.2    : Some Notice: Undefined variable: for different variables
           sv('REQUEST_URI') changed to support IIS
- Beta 9 : Bug corrected when showing NEXT/PREV above thumbnails, thanks to Geniz
- Beta 8 : Bugs corrected when running i REGISTER GLOBAL off enviroment
           New parameter in config.php file:
           $plugin_cf['gallery']['memory_limit']="8M";
- Beta 7 : More error handline implemented, parameters moved to config.php file
           $plugin_cf['gallery']['thumb_size']="125";
           $plugin_cf['gallery']['thumb_quality']="75";
           $plugin_cf['gallery']['main_max_size']="350";
           $plugin_cf['gallery']['number_of_thumbs']="6";
           $plugin_cf['gallery']['show_title']="True";
           $plugin_cf['gallery']['show_comments']="True";
- Beta 6 : Bug corrected when pics to show is greater than pics in gallery.
- Beta 5 : Bug corrected, header('Location:.. '.sv('REQUEST_URI')); 
           changed to header('Location: '.sv('REQUEST_URI')); 
           causes multilanguage gallery to return to 
           wrong page after inserting comment
- Beta 4 : ALT tag added to images to make output HTML 4.01 valid
- Beta 3 : $tx['gallery']['name_form']="Name";
           $tx['gallery']['comment_form']="Comment";
- Beta 2 : CRLF in comment causes new comment is fixed.
- Beta 1 : First beta released
*/

//function gallery($dir,$showpic='',$max_size='')
function gallery($dir,$pconfiguration='',$showpic='',$max_size='')
{
global $cf,$plugin_cf,$plugin_tx,$tx,$sn,$su,$pth,$hjs,$sl,$files,$title_array,$gallery_conf,$gallery_rel_attrib;

$plugin=basename(dirname(__FILE__),"/");
$plugin_include_folder=$pth['folder']['plugins'].$plugin."/includes/";

include_once $plugin_include_folder."thumbcreate.php";

if(substr($dir, -1, 1)<>'/')$dir =$dir."/";
$debug = isset($_POST['debug']) ? $_POST['debug'] : '';
if($debug){error_reporting(E_ALL);}

$t=''; $WinOS=''; $search_array='';
if (!isset($hjs)) { $hjs=''; }

/*
* HI Multiple CSS and configurations - Thanks goes to Peter alias Infantilo
*
* NOTE:
* For manipulation and creating thumbnails always the settings in 
* the default file 'config.php' are used.
* Until now it's not possible to use another config and/or css in admin-mode as the
* default files 'config.php' and 'stylesheet.css'.
*
*/

$gallery_conf="config"; //Set default config_filename

if ($pconfiguration != '') {
   $pconf =$pth['folder']['plugins'].$plugin."/config/".$pconfiguration.".php";
   $pcss =$pth['folder']['plugins'].$plugin."/css/".$pconfiguration.".css";
   if(file_exists($pconf)) {
        include_once $pconf;
        $gallery_conf=$pconfiguration;
   }
   if(file_exists($pcss)){
       $hjs .= "\n".'<style type="text/css">'.rf($pcss).'</style>'."\n"; // at this point the styles form default-stylesheet.css are overwritten by the new $pcss in head-section
       }  
}

// End of Multiple Configs and CSS - mod


//Get string for the "rel= ..." - attrib from the config switch
$gallery_rel_attrib = $plugin_cf['gallery']['use_rel_attrib'];


//**************************************************************************
// Write the PopUp-JS to head section if no Lightbox-script is used
if(!eregi("true",$plugin_cf['gallery']['use_lightbox'])){
	$hjs=popup_java_code().$hjs;
}


//**************************************************************************

//Load external (Lightbox)-Script by gallery if defined in config

//$plugin_cf['gallery']['use_external_lib'] = "greybox"; //HI Debug
//$plugin_cf['gallery']['use_external_lib'] = "slimbox_mod"; //HI Debug
//$plugin_cf['gallery']['use_external_lib'] = "lightbox2"; //HI Debug

if ($plugin_cf['gallery']['use_external_lib'] != '') {
	if (file_exists($pth['folder']['plugins'] .$plugin. "/libs/" .$plugin_cf['gallery']['use_external_lib']. "/" .$plugin_cf['gallery']['use_external_lib']. ".php")) {
		include_once ($pth['folder']['plugins'] .$plugin. "/libs/" .$plugin_cf['gallery']['use_external_lib']. "/" .$plugin_cf['gallery']['use_external_lib']. ".php");
	}
	else {
		$t .= "<b>Gallery plugin Error :</b> Could not load " . $pth['folder']['plugins'] .$plugin. "/libs/" . $plugin_cf['gallery']['use_external_lib'] . "/" . $plugin_cf['gallery']['use_external_lib'] . ".php <br><br><b>Solution : </b>Please check config setting [use_external_lib]<br>and / or files and path to external libraries";
		return $t;
		exit;
	}
}

//***************************************************************************	


if(eregi("true",$plugin_cf['gallery']['check_for_gd'])){$CheckGD = get_extension_funcs("gd");if(!$CheckGD){$t .= "<br>Gallery plugin Error :</b> GD image library not installed!<br><br><b>Solution:</b> Your server does not meet the requirements for the gallery plugin, install the GD lib";return $t;exit;}}

if(headers_sent($filename,$linenum)){$t .= "<b>Gallery Plugin Error :</b> Gallery plugin detected that someone already had sent headers<br><br><b>Solution :</b> Look for the error in $filename line $linenum, typical a space or empty line";return $t;exit;}

if($showpic=='') $showpic=$plugin_cf['gallery']['number_of_thumbs'];
if($max_size=='') $max_size=$plugin_cf['gallery']['main_max_size'];

$pic = getvariable('pic');
$page = getvariable('page');

$action = getvariable('action');
$search_string = getvariable('search_string');
$comment_name = getvariable('comment_name');
$comment_text = getvariable('comment_text');
$comment_text = str_replace("\r\n", " ", $comment_text);

$dirs=explode("/",$dir);
$dirs = array_diff($dirs, array("")); // remove blank elements
$folder_create = "";

/* HI foreach ($dirs as $folders => $folder){
$folder_create .= $folder."/";
if(!file_exists($folder_create))
  {$old_umask=umask(0);
   if($debug){echo "Debug info 1: folder_create: $folder_create</br>";}
   if($folder_create){
   $uid =getmyuid();
   $gid =getmygid();
   mkdir($folder_create,0777);
   chown($folder_create,$uid);
   chgrp($folder_create,$gid);
   }
   umask($old_umask);
  }
  
if(!is_dir($folder_create)){$t.="<b>Gallery Plugin Error :</b> $folder_create folder could not be created!<br><br><b>Solution :</b>Please create the folder using your ftp account!";return $t;exit;}
  
if(!is_readable($folder_create)){$t.="<b>Gallery Plugin Error :</b> $folder_create folder is not readable!<br><br><b>Solution :</b>Please chmod folder to 0777, at the moment it is ".substr(sprintf('%o', fileperms($folder_create)), -4)."!";return $t;exit;}

if(!is_writable($folder_create)){$t.="<b>Gallery Plugin Error :</b> $folder_create folder is not writable!<br><br><b>Solution :</b>Please chmod folder to 0777, at the moment it is ".substr(sprintf('%o', fileperms($folder_create)), -4)."!";return $t;exit;}

if(strpos($_SERVER['SERVER_SOFTWARE'], 'Win') !== false){$WinOS=True;}
if(strpos($_SERVER['SERVER_SOFTWARE'], 'IIS') !== false){$WinOS=True;}

if (function_exists('getmyuid') and !$WinOS){
if(getmyuid()){if(fileowner($folder_create)<>getmyuid()){$t.="<b>Gallery plugin Error :</b> Creation of dir ($folder_create)<br><br><b>Solution : </b>Please check owner of folder $folder_create (".realpath($folder_create).")<br>The owner seems to be [".fileowner($folder_create)."] the script expects [".getmyuid()."], solve by deleting the folder <b><i>$folder_create</i></b> and re-create it using your FTP account.";return $t;exit;}}}

if (function_exists('is_executable') and !$WinOS and substr(sprintf('%o', fileperms($folder_create)), -4)<>'0777'){
if(!is_executable($folder_create)){$t.="<b>Gallery Plugin Error :</b> $folder_create folder is not executable!<br><br><b>Solution :</b>Please chmod folder to 0777, at the moment it is ".substr(sprintf('%o', fileperms($folder_create)), -4)."!";return $t;exit;}}
} */
foreach ($dirs as $folders => $folder){
$folder_create .= $folder."/";
if(!file_exists($folder_create)) mkdir($folder_create,0777);
}
//HI

$dir = $folder_create;
if(!is_dir($dir)){$t .="<b>Gallery Plugin Error :</b> Could not create folder $dir!<br><b>Solution :</b> Create $dir (".realpath($dir).") using your ftp account and chmod 777!";return $t;exit;}

if (@opendir($dir)){
$files = LoadFilesArray($dir);

foreach($files as $key=>$file){
$title_array[$key] = array();
$time_array[$key] = array();
$comment_array[$key] = array();
$name_array[$key] = array();
$extrainfo_array[$key] = array();
$search_array = array();
$filename = filename_for_comments($dir.$file);
if(file_exists($filename)){
$fp=fopen($filename,"r");
$line = fgets( $fp, 2024 );
$title = explode(";", $line);
array_push($title_array[$key], $title[0]);
foreach($title as $j=>$i){if(($j>0) and strlen($title[$j])>'0'){
//HI No html in extrainfo: 
array_push($extrainfo_array[$key], htmlspecialchars($title[$j], ENT_QUOTES));}}

//HI or use html in extrainfo enabled with the next line:
//array_push($extrainfo_array[$key], $title[$j]);}}

while(!feof($fp)){$i=0;$line = fgets( $fp, 2024 );list($time,$comment,$name) = split( ";", $line);array_push($time_array[$key], $time); array_push($comment_array[$key], $comment); array_push($name_array[$key], $name); $i++ ;}fclose($fp);}else{array_push($title_array[$key], strtolower($file));}}

//search text
if(!$search_string and $action=='search'){
$action='';
}
if($search_string and $action=='search'){

foreach($files as $key=>$file){
$filename = filename_for_comments($dir.$file);
if(file_exists($filename)){
$fp=fopen($filename,"r");
$line = fread($fp, filesize($filename));
if(stristr($line,$search_string))array_push($search_array, $key);
}}
if(!$search_array)
$t .= "<div class=\"search_nothing\">".$plugin_tx['gallery']['search_nothing']."</div><br>";
$action='';
}
//Add comment
if($pic<>'' and $action=='writecomment'){
$file=preg_replace("/.jpg/i",".txt",$files[$pic]);
if(eregi("true",$plugin_cf['gallery']['multilanguage_comments'])){if($sl!=$cf['language']['default']){$file=preg_replace("/.jpg/i","-".$sl.".txt",$files[$pic]);}}
$now = date($plugin_tx['gallery']['comments_datesformat'],time());
$handle = fopen("$dir"."$file", "a");
fwrite($handle, "\r\n$now;$comment_name;$comment_text;");
fclose($handle);
unset($_GET['action']);

if(eregi("true",$plugin_cf['gallery']['addcomment_redir_to_thumbview'])){
if (!$page){
//header("Location: http://".sv('HTTP_HOST').((dirname(sv('PHP_SELF')) == "/") ? "/" : dirname(sv('PHP_SELF'))."/")."?".sv('QUERY_STRING'));
header("Location: ".$sn."?".$su);exit;
}else{
//header("Location: http://".sv('HTTP_HOST').((dirname(sv('PHP_SELF')) == "/") ? "/" : dirname(sv('PHP_SELF'))."/")."?".sv('QUERY_STRING')."&amp;page=".$page);
header("Location: ".$sn."?".$su."&amp;page=".$page);exit;
}}
else{
if(!$page){
//header("Location: http://".sv('HTTP_HOST').((dirname(sv('PHP_SELF')) == "/") ? "/" : dirname(sv('PHP_SELF'))."/")."?".sv('QUERY_STRING')."&amp;pic=".$pic);
header("Location: ".$sn."?".$su."&amp;pic=".$pic);exit;
}else{
//header("Location: http://".sv('HTTP_HOST').((dirname(sv('PHP_SELF')) == "/") ? "/" : dirname(sv('PHP_SELF'))."/")."?".sv('QUERY_STRING')."&amp;pic=".$pic."&amp;page=".$page);
header("Location: ".$sn."?".$su."&amp;pic=".$pic."&amp;page=".$page);exit;
}}
exit;}

if($pic<>'' and $action=='addcomment'){
$t .= AddComment($dir,$pic);
return $t;
}

// Show picture
if($pic<>'' and $action==''){
//$hjs=popup_java_code().$hjs; //Moved to top of function to get PopUp from thumb
$filename = filename_for_comments($dir.$files[$pic]);

if(file_exists($filename)){if($fp = fopen ($filename, "r")) {$indhold = fread($fp,4096);fclose($fp);}}

$next = $pic+1;$prev = $pic-1;
$title = $title_array[$pic][0];

if($page=='') $page=0;
$showpic = (isset($showpic)) ? $showpic : count($files);
if($showpic=='') $showpic = count($files);
if($showpic > count($files))$showpic=count($files);

if ($next+1 > count($files)){$next=0;}
if ($prev < 0){$prev=count($files)-1;}

$page = floor($pic/$showpic);

$title = preg_replace("/_/i", " ", $title_array[$pic][0]);
$title = stripslashes(preg_replace("/'/", '&#39;', $title));

//HI Hide or show navigation in top of details-page
if((eregi("top",$plugin_cf['gallery']['nav_position_details']))OR(eregi("both",$plugin_cf['gallery']['nav_position_details']))){

$t .= "<div class=\"gallery_legend\">";
$t .= "<a href=\"$sn?$su&amp;page=".$page."\">".$plugin_tx[$plugin]['return_to_thumb']."</a>".tag('br');
$t .= "<a href=\"$sn?$su&amp;pic=".$prev."&amp;page=".$page."\">".$plugin_tx['gallery']['prev']."</a>"."&nbsp;&nbsp;";
$t .= $plugin_tx['gallery']['image']." ".($pic+1)." ".$plugin_tx['gallery']['of']." ".count($files);
$t .= "&nbsp;&nbsp;<a href=\"$sn?$su&amp;pic=".$next."&amp;page=".$page."\">".$plugin_tx['gallery']['next']."</a>".tag('br')."</div>";
} //HI

$t .= "<fieldset class=\"gallery_fieldset\">";
if(eregi("true",$plugin_cf['gallery']['show_title']) and eregi("top",$plugin_cf['gallery']['title_placement']))$t .= "<p class=\"gallery_title\">".$title."</p>";

$t .="<div class=\"gallery_pic\">".ShowPicture($dir,$files[$pic],'true',$title)."</div>";

if(eregi("true",$plugin_cf['gallery']['show_title']) and eregi("bottom",$plugin_cf['gallery']['title_placement']))$t .= "<p class=\"gallery_title\">".$title."</p>";
if($plugin_tx['gallery']['general_text']){$t .= "<div class=\"general_text\">".tag('br').$plugin_tx['gallery']['general_text']."</div>";}
if(eregi("true",$plugin_cf['gallery']['show_extrainfo'])){
  $t.="<div class=\"gallery_extrainfo\">";
foreach($extrainfo_array[$pic] as $i=>$extrainfo){
$extra_field = explode(",", $plugin_tx['gallery']['extra_info_fields']);
if(trim($extrainfo)){$t .= "<b>"."$extra_field[$i]".$plugin_tx['gallery']['extra_info_spacer']."</b>".stripslashes($extrainfo).tag('br');}
}
$t .= tag('br');
 
$t.="</div>";
}

if(eregi("true",$plugin_cf['gallery']['show_comments'])){
$t .= "<div class=\"gallery_addcomment\">";
$t .= "<a href=\"$sn?$su&amp;action=addcomment&amp;pic=".$pic."&amp;page=".$page."\">".$plugin_tx['gallery']['add_comment']."</a>".tag('br').tag('br');
foreach ($comment_array[$pic] as $comments=>$temp)
{
$t .= "<b>".stripslashes($comment_array[$pic][$comments])."</b>".tag('br');

$t .= $time_array[$pic][$comments]." | ".htmlspecialchars(stripslashes($name_array[$pic][$comments])).tag('hr');
}$t .= "</div>";}     //HI
$t .= "</fieldset>";  //HI

//Navigation after picture on details-page
if((eregi("bottom",$plugin_cf['gallery']['nav_position_details']))OR(eregi("both",$plugin_cf['gallery']['nav_position_details']))){
$t .= "<div class=\"gallery_legend\">";
$t .= "<a href=\"$sn?$su&amp;page=".$page."\">".$plugin_tx[$plugin]['return_to_thumb']."</a>".tag('br');
$t .= "<a href=\"$sn?$su&amp;pic=".$prev."&amp;page=".$page."\">".$plugin_tx['gallery']['prev']."</a>"."&nbsp;&nbsp;";
$t .= $plugin_tx['gallery']['image']." ".($pic+1)." ".$plugin_tx['gallery']['of']." ".count($files);
$t .= "&nbsp;&nbsp;<a href=\"$sn?$su&amp;pic=".$next."&amp;page=".$page."\">".$plugin_tx['gallery']['next']."</a>".tag('br')."</div>";
}
//Navigation after picture on details-page

return $t;
}

// Creates thumbnails and files for comments and titles
if($pic=='' and $action=='')
{
$thumbdir=$dir."thumb";
/*HI
if(!file_exists($thumbdir)){
if($debug){echo "Debug[3]: thumbdir: $thumbdir</br>";}
$old_umask=umask(0);
  $uid =getmyuid();
  $gid =getmygid();
  mkdir($thumbdir,0777);
  chown($thumbdir,$uid);
  chgrp($thumbdir,$gid);
  umask($old_umask);
}*/
if(!file_exists($thumbdir)) mkdir($thumbdir,0777); // HI Hier noch eine Fehlermeldung einbauen!
//HI

/*HI
if($debug){echo "Debug[4]: thumbdir: $thumbdir ".substr(sprintf('%o', fileperms($thumbdir)), -4)."</br>";}
if(!is_readable($thumbdir)){$t.="<b>Gallery Plugin Error :</b> $thumbdir folder is not readable!<br><br><b>Solution :</b>Please chmod folder to 0777, at the moment it is ".substr(sprintf('%o', fileperms($thumbdir)), -4)."!";return $t;exit;}

if(!is_writable($thumbdir)){$t.="<b>Gallery Plugin Error :</b> $thumbdir folder is not writable!<br><br><b>Solution :</b>Please chmod folder to 0777, at the moment it is ".substr(sprintf('%o', fileperms($thumbdir)), -4)."!";return $t;exit;}
if (function_exists('is_executable') and !$WinOS and substr(sprintf('%o', fileperms($folder_create)), -4)<>'0777'){
if(!is_executable($thumbdir)){$t.="<b>Gallery Plugin Error :</b> $thumbdir folder is not executable!<br><br><b>Solution :</b>Please chmod folder to 0777, at the moment it is ".substr(sprintf('%o', fileperms($thumbdir)), -4)."!";return $t;exit;}}
if(!is_dir($thumbdir)){
$t.="<b>Gallery plugin Error :</b> Creation of thumbs dir failed ($thumbdir)<br><br><b>Solution : </b>Please check owner of folder $dir (".realpath($dir).")<br>Delete the folder <b><i>$dir</i></b> and creating again it using your FTP account.";return $t;exit;}

if(!@opendir($thumbdir)){$t .="<b>Gallery plugin Error :</b> Folder created, but script have no access to $thumbdir, (".substr(sprintf('%o', fileperms($thumbdir)), -4).")<br><b>Solution : </b> Delete the folder and create it using ftp if running in safe mode";return $t;exit;}

if (function_exists('getmyuid') and !$WinOS){
if(getmyuid()){if(fileowner($thumbdir)<>getmyuid()){$t.="<b>Gallery plugin Error :</b> Creation of thumbs dir failed ($thumbdir)<br><br><b>Solution : </b>Please check owner of folder $thumbdir (".realpath($thumbdir).")<br>The owner seems to be [".fileowner($thumbdir)."] the script expects [".getmyuid()."], solve by deleting the folder <b><i>$thumbdir</i></b> and re-create it using your FTP account.";return $t;exit;}}}
*/
if(!touch($dir."thumb/testfile.txt")){$t.= tag('br')."<b>Gallery plugin Error :</b> Gallery is not allowed to work with files inside the thumb dir!<br><br><b>Solution :</b> Please delete the folder <b><i>$thumbdir (".realpath($thumbdir).")</i></b> and re-create it using your FTP account.";return $t;exit;}

if(file_exists($dir."thumb/testfile.txt"))unlink($dir."thumb/testfile.txt");

$new_thumb=0;

if(trim($plugin_cf['gallery']['thumb_size'])==''){$t .="<b>Gallery Plugin Error :</b> No value for thumb_size!<br><br><b>Solution :</b> Check in admin mode or check if /config/config.php exsist for the gallery";return $t;}

//HI 081 $t .= "<fieldset class=\"gallery_fieldset\">";

switch(count($files)){
case 1:
   $picture_text = $plugin_tx['gallery']['picture_in_this_gallery'];
   break;
case 2:
   $picture_text = $plugin_tx['gallery']['pictures_in_this_gallery'];
   break;
case 3:
   $picture_text = $plugin_tx['gallery']['pictures_in_this_gallery'];
   break;
case 4:
   $picture_text = $plugin_tx['gallery']['pictures_in_this_gallery'];
   break;
default:
   $picture_text = $plugin_tx['gallery']['more_pictures_in_this_gallery'];
}

//HI if(!$search_array){$t .= "<div class=\"gallery_legend\">".count($files)." ".$picture_text."</div>".tag('br');}else{$t .= "<div class=\"gallery_legend\">".count($search_array)."   ".$plugin_tx['gallery']['pictures_found_in_search']." &#34;".$search_string."&#34;</div>".tag('br');}
	if(!$search_array){
		if(eregi("true",$plugin_cf['gallery']['show_nbr_of_pics'])){
		$t .= "<div class=\"gallery_heading\">".count($files)." ".$picture_text."</div>";
		}
	}
	else {
	$t .= "<div class=\"gallery_heading\">".count($search_array)."   ".$plugin_tx['gallery']['pictures_found_in_search']." &#34;".$search_string."&#34;</div>";
	}

//HI to line 348   $t .= "<fieldset class=\"gallery_fieldset\">"; //HI /081

foreach ($files as $key=>$file){$t .=CreateImagetxtFile($dir,$file);}

if($page=='') $page=0;
$showpic = (isset($showpic)) ? $showpic : count($files);
if($showpic=='') $showpic = count($files);
if($showpic > count($files))$showpic=count($files);

$startpic = $page*$showpic;
$stoppic = ($page*$showpic)+$showpic-1;

if($stoppic >= count($files)-1){$stoppic=count($files)-1;$nextpage=0;$prevpage=$page-1;}
else
{$nextpage=$page+1;$prevpage=$page-1;}

//HI Hide or show the navigation in top of thumb-page
if((eregi("top",$plugin_cf['gallery']['nav_position_thumb']))OR(eregi("both",$plugin_cf['gallery']['nav_position_thumb']))){
//
if(count($files)>0){if($prevpage<0){$prevpage=round(count($files)/$showpic)-1;}}

if($showpic<>count($files)){
if(!$search_array){$t .= "<div class=\"gallery_legend\">"; //HI was class gallery_pic
$t .= "<a href=\"".$sn."?"."".$su."&amp;page=$prevpage\">".$plugin_tx['gallery']['prev']."</a>";
$t .= "&nbsp;&nbsp;".$plugin_tx['gallery']['page']."&nbsp;".($page+1)."&nbsp;".$plugin_tx['gallery']['of']."&nbsp;".ceil(count($files)/$showpic);
$t .= "&nbsp;&nbsp;<a href=\"".$sn."?"."".$su."&amp;page=$nextpage\">".$plugin_tx['gallery']['next']."</a></div>";
$t .= tag('br');
}}
} //HI

$t .= "<fieldset class=\"gallery_fieldset\">"; //HI /081

// Makes the thumb from the original picture
if($search_array)$stoppic = count($files)-1;
for($key = $startpic; $key <= $stoppic; $key++){
  $file = $files[$key];
    
    if(!file_exists("$dir"."thumb/tn_$file"))
            {
            if(CreateThumb($dir,$file)){return CreateThumb($dir,$file);exit;}
            $new_thumb = 1;
            }
           else
{$comment_data = $plugin_tx['gallery']['no_comment'];

foreach ($comment_array[$key] as $comments=>$temp){
if(count($comment_array[$key])>0){$comment_data = count($comment_array[$key])." ".$plugin_tx['gallery']['comment'];}
if(count($comment_array[$key])>1){$comment_data = count($comment_array[$key])." ".$plugin_tx['gallery']['comments'];}
}
 $title = preg_replace("/_/i", " ", $title_array[$key][0]);
 $title = stripslashes(preg_replace("/'/", '&#39;', $title));
if(!$search_array){
 $t .= "<div class=\"thumbnailitem\">";
if(eregi("true",$plugin_cf['gallery']['show_title']) and eregi("top",$plugin_cf['gallery']['title_placement']))$t .= $title . tag ('br');


//HI Modified to get a Lightbox-Picture-Set or a PopUp direct from Thumb-View

if(eregi("true",$plugin_cf['gallery']['show_bigpic_direct_from_thumb'])){
       $t .= ShowFromThumb($dir,$file,$title);
       }
else {
$t .= "<a href=\"".$sn."?"."".$su."&amp;pic=$key&amp;page=$page\" class=\"thumb\">";
     }
// HI

$t .= ShowPicture($dir.'thumb/tn_',$file,'',$title);
//$t .= tag('br');
if(eregi("true",$plugin_cf['gallery']['show_title']) and eregi("bottom",$plugin_cf['gallery']['title_placement']))$t .= tag('br') . $title;
if(eregi("true",$plugin_cf['gallery']['show_comments']))$t .= tag('br') . "<sup>".$comment_data."</sup>";
$t .= "</div>";    
}
if(in_array($key,$search_array)){
 $t .= "<div class=\"thumbnailitem\">";
if(eregi("true",$plugin_cf['gallery']['show_title']) and eregi("top",$plugin_cf['gallery']['title_placement']))$t .= $title .tag('br');


//HI Modified to get a Lightbox-Picture-Set / PopUp direct from Thumb-View in search-result

if(eregi("true",$plugin_cf['gallery']['show_bigpic_direct_from_thumb'])){
       $t .= ShowFromThumb($dir,$file,$title);
       }
else {
$t .= "<a href=\"".$sn."?"."".$su."&amp;pic=$key&amp;page=$page\" class=\"thumb\">";
     }
// end of modification - HI

$t .= ShowPicture($dir,'thumb/tn_'.$file,'',$title);
$t .= tag('br');

if(eregi("true",$plugin_cf['gallery']['show_title']) and eregi("bottom",$plugin_cf['gallery']['title_placement']))$t .= $title . tag('br');
if(eregi("true",$plugin_cf['gallery']['show_comments']))$t .= "<sup>".$comment_data."</sup>";
$t .= tag('br')."</div>";
}
}}
$t .= "</fieldset>"; //HI


//Navigation after thumbs

if((eregi("bottom",$plugin_cf['gallery']['nav_position_thumb']))OR(eregi("both",$plugin_cf['gallery']['nav_position_thumb']))){
if(count($files)>0){if($prevpage<0){$prevpage=round(count($files)/$showpic)-1;}}

if($showpic<>count($files)){
if(!$search_array){$t .= "<div class=\"gallery_legend\">"; //HI was class gallery_pic
$t .= "<a href=\"".$sn."?"."".$su."&amp;page=$prevpage\">".$plugin_tx['gallery']['prev']."</a>";
$t .= "&nbsp;&nbsp;".$plugin_tx['gallery']['page']."&nbsp;".($page+1)."&nbsp;".$plugin_tx['gallery']['of']."&nbsp;".ceil(count($files)/$showpic);
$t .= "&nbsp;&nbsp;<a href=\"".$sn."?"."".$su."&amp;page=$nextpage\">".$plugin_tx['gallery']['next']."</a></div>";
$t .= tag('br');
}}
}
//Navigation after thumbs


if(eregi("true",$plugin_cf['gallery']['show_search'])){
//HI $t .= "</fieldset>";
$t .= "<form method=\"post\" action=\"$sn?$su\">";
//HI $t .= "<p>".tag('input type="hidden" name="action" value="search"')."</p>";
//HI $t .= "<p class=\"gallery_search\">".$plugin_tx['gallery']['search_text']." ".tag('input type="text" name="search_string" class="gallery_input"');
$t .= tag('input type="hidden" name="action" value="search"');
$t .= "<div class=\"gallery_search\">".$plugin_tx['gallery']['search_text']." ".tag('input type="text" name="search_string" class="gallery_input"');
$t .= tag('input type="submit" value="'.$plugin_tx['gallery']['search_button'].'" class="gallery_submit"')."</div>";
$t .= "</form>";}
}}
if($new_thumb==1){
//header"Location: http://".sv('HTTP_HOST').((dirname(sv('PHP_SELF')) == "/") ? "/" : dirname(sv('PHP_SELF'))."/")."?".sv('QUERY_STRING'));
header("Location: ".$sn."?".$su);exit;
}
return $t;
}
?>